(defun c:SObjekty ()
;;; definice nov funkce kresli
  (setq	gl_pam_hodnoty		;;; globln promnn uchovvajc jednotliv nastaven
     (list
	(cons "co_kreslit"   "Kruznice")	;;; uren co se bude kreslit
	(cons "stredkex"     "0.0")		;;; x-ova souadnice stedu sost. krunic
	(cons "stredkey"     "0.0")		;;; y-ova souadnice stedu sost. krunic
	(cons "stredkez"     "0.0")		;;; z-ova souadnice stedu sost. krunic
	(cons "strednex"     "0.0")		;;; x-ova souadnice stedu sost. n-uhelnk
	(cons "stredney"     "0.0")		;;; y-ova souadnice stedu sost. n-uhelnk
	(cons "strednez"     "0.0")		;;; z-ova souadnice stedu sost. n-uhelnk
	(cons "pocvrcholune" "3")		;;; poet vrchol n - helnku (editbox)
	(cons "pocvrcholuns" "3")		;;; poet vrchol n - helnku (slider)
	(cons "polomerne"    "3")		;;; polomr n - helnku (editbox)
	(cons "polomerns"    "3")		;;; polomr n - helnku (slider)
	(cons "pocetne"      "1")		;;; poet n - helnk (editbox)
	(cons "pocetns"      "1")		;;; poet n - helnk (slider)
	(cons "vzdalenostne" "1")		;;; vzdlenost mezi n - helnky (editbox)
	(cons "vzdalenostns" "1")		;;; vzdlenost mezi n - helnky (slider)
	(cons "polomerke"    "1")		;;; polomr krunice (editbox)
	(cons "polomerks"    "1")		;;; polomr krunice (slider)
	(cons "pocetke"      "1")		;;; poet krunic (editbox)
	(cons "pocetks"      "1")		;;; poet krunic (slider)
	(cons "vzdalenostke" "1")		;;; vzdlenost mezi krunicemi (editbox)
	(cons "vzdalenostks" "1")		;;; vzdlenost mezi krunicemi (slider)
	(cons "kruz_stred_but"  "0")		;;; tlatko - stred kruznice
	(cons "nuhel_stred_but" "0")		;;; tlatko - stred n helnku
     )
  )

  (setq zadani (so:zpusob_zadani))      ;;; nastaven promnn urujc jakm
  					;;; zpsobem se maj zadat informace
  (if (= zadani "prikaz")		;;; zadn hodnot pomoc pkazovho dku
    (if	(= (so:zadej_hodnoty) T)
      (so:vykresli)			;;; vykreslen poadovanho objektu,
      					;;; v ppad e byly zadny hodnoty
    )
  )
  (if (= zadani "dialog")		;;; adn hodnot pomoc dialogovho boxu
    (if	(= (so:dialog) T)
      (so:vykresli)			;;; vykreslen poadovanho objektu,
      					;;; v ppad e byly zadny hodnoty  
    )
  )
  (princ "Funkce c:SObjekty dokonila innost")	;;; informace o ukonen funkce
  (princ)
)

 
(defun so:dialog (/ id co_delat vysledek)
  (princ "Tady bude v budoucnu dialogov box!")
  T						;;; aby se daly otestovat i nvazn funkce
)


(defun so:naskruh ()
  (princ "Tady bude nastaven vech pepna dialogovho boxu pro volbu krunice!")
  (princ)
)

(defun so:nasnuhe ()
  (princ "Tady bude nastaven vech pepna dialogovho boxu pro volbu n-helnku!")
  (princ)
)

(defun zaokr_string (string)
  (princ "Tady bude pevodn funkce etzec reprezentujc float -> etzec reprezentujc int!")
  (princ)
)

(defun so:zpusob_zadani	(/ vysledek)	;;; funkce vrac etzec urujc zpsob zadn hodnot
  (initget "D P _dialog prikaz")	;;; uren monch vstupnch hodnot
  (setq	vysledek
    (getkword "Jakm zpsobem si pejete zadat hodnoty (Dialog / Pkazov_ dek)? :")
  )					;;; zskn klovho slova pro pokraovn
  vysledek				;;; pedn nvratov hodnoty nadazen funkci
)

(defun so:zadej_hodnoty	(/ vysledek)	;;; funkce pro zadn hodnot
  (setq vysledek nil)
  (initget "K N _Kruznice N-uhelnik ")	;;; uren monch vstupnch hodnot
  (setq	co_kreslit
    (getkword "Jak objekty mm kreslit (Krunice / N helnk)? :")
  )					;;; zskn klovho slova pro pokraovn
  (setq	gl_pam_hodnoty
    (subst
       (cons  "co_kreslit" co_kreslit)
       (assoc "co_kreslit" gl_pam_hodnoty)
       gl_pam_hodnoty
    )
  )

  (so:nastav_stred (getpoint "\nZadej sted obrazce: "))
  
  (if (= co_kreslit "Kruznice")		;;; uivatel poaduje kreslit krunici
    (progn
      (initget 1)	;;; kontrola zadn seln hodnoty ( 0 potvrzen zadn je ENTREM)
      (setq polomerk (getreal "\n Zadej polomr krunice: "))
      			;;; zjistn hodnoty polomru
      (setq gl_pam_hodnoty
        (subst
	  (cons  "polomerke" (vl-princ-to-string polomerk))
 	  (assoc "polomerke" gl_pam_hodnoty)
	  gl_pam_hodnoty
        )
      )			;;; uloen hodnoty polomru krunice do asoc. seznamu gl_pam_hodnoty

      (initget 1)	;;; kontrola zadn seln hodnoty ( 0 potvrzen zadn je ENTREM)
      (setq pocetk (getint "\n Zadej poet nakreslench krunic: "))
			;;; zadn potu kreslench krunic
      (setq gl_pam_hodnoty
        (subst
	  (cons  "pocetke" (itoa pocetk))
	  (assoc "pocetke" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen potu krunic z promnn pocetk
      			;;; do asoc. seznamu gl_pam_hodnoty

      (initget 1)	;;; kontrola zadn seln hodnoty ( 0 potvrzen zadn je ENTREM)
      (setq vzdalenostk (getreal "\n Zadej vzdlenost mezi krunicemi: "))
			;;; zadn vzdlenosti mezi krunicemi
      (setq gl_pam_hodnoty
        (subst
	  (cons  "vzdalenostke" (vl-princ-to-string vzdalenostk))
	  (assoc "vzdalenostke" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen vzdlenosti mezi krunicemi z promnn
      			;;; vzdalenostk do asoc. seznamu gl_pam_hodnoty
    (setq vysledek T)
    )    
  )
  
  (if (= co_kreslit "N-uhelnik")	;;; uivatel poaduje kreslit n-helnk
    (progn
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq pocvrcholun (getint "\n Zadej poet vrchol n-helnku: "))
			;;; zadn poetu vrchol n-helnku
      (setq gl_pam_hodnoty
	(subst
	  (cons  "pocvrcholune" (itoa pocvrcholun))
	  (assoc "pocvrcholune" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen potu vrchol z promnn pocvrcholun
      			;;; do asoc. seznamu gl_pam_hodnoty
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq polomern (getreal "\n Zadej polomr opsan krunice n-helnku: "))
			;;; zadn hodnoty polomru prvn vepsan krunice
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq gl_pam_hodnoty
	(subst
	  (cons  "polomerne" (vl-princ-to-string polomern))
	  (assoc "polomerne" gl_pam_hodnoty)
      	  gl_pam_hodnoty
        )
      )			;;; uloen polomru prvn vepsan krunice z promnn
	    		;;; polomern do asoc. seznamu gl_pam_hodnoty
      (setq pocetn (getint "\n Zadej poet n-helnk: "))
			;;; zadn hodnoty poetu kreslench n-helnk
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq gl_pam_hodnoty
	(subst
	  (cons  "pocetne" (itoa pocetn))
	  (assoc "pocetne" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen potu kreslench n-helnk z promnn pocetne
      			;;; do asoc. seznamu gl_pam_hodnoty
      (setq vzdalenostn (getreal "\n Zadej vzdlenost mezi n-helnky: "))
			;;; zadn vzdlenosti mezi n-helnky
      (setq gl_pam_hodnoty
	(subst
	  (cons  "vzdalenostne" (vl-princ-to-string vzdalenostn)) 
          (assoc "vzdalenostne" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )			;;; uloen vzdlenosti mezi n-helnky z promnn vzdalenostne
      			;;; do asoc. seznamu gl_pam_hodnoty

      (if (< pocvrcholun 3)	;;; oeten chybnho zadn
        (progn
          (princ "\n Zvtil jsem poet vrchol n-helnku na minimln poet 3")
          (setq gl_pam_hodnoty
	    (subst
	      (cons "pocvrcholune" "3")
	      (assoc "pocvrcholune" gl_pam_hodnoty)
	      gl_pam_hodnoty
	    )
          )		;;; oprava hodnoty v promnn gl_pam_hodnoty
        )
      )			;;; oeten chybnho zadn

      (if (< polomerne 30)	;;; oeten chybnho zadn
	(progn
  	  (princ "\n Zvtil jsem polomr n-helnku poet 30")
  	  (setq	gl_pam_hodnoty
	    (subst
	      (cons "polomerne" "30")
	      (assoc "polomerne" gl_pam_hodnoty)
	      gl_pam_hodnoty
	    )
          )		;;; oprava hodnoty v promnn gl_pam_hodnoty
	)
      )
      (setq vysledek T)
    )
  )
  vysledek
)

(defun so:vykresli (/ co_kreslit)
  (setq co_kreslit (cdr (assoc "co_kreslit" gl_pam_hodnoty)))
  	;;; zskn klovho slova pro uren dalho postupu pokraovn
  (if (= co_kreslit "Kruznice")		;;; uivatel poaduje kreslit krunici
    (so:kresli_kruznici)		;;; voln funkce pro vykreslen krunice
  )
  (if (= co_kreslit "N-uhelnik")	;;; uivatel poaduje kreslit n-helnk
    (so:kresli_nuhelnik)		;;; voln funkce pro vykreslen n-helnku
  )
)

(defun so:nastav_stred (stred / stredx stredy stredz)
;;; funkce pro nastaven hodnot souadnic stedu do globln promnn gl_pam_hodnoty
  (setq stredx (strcat (vl-princ-to-string (car stred))))
  (setq stredy (strcat (vl-princ-to-string (cadr stred))))
  (setq stredz (strcat (vl-princ-to-string (caddr stred))))
  (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "Kruznice")	;;; jak sted se nastavuje
    (progn							;;; nastavujeme sted krunice
      (setq gl_pam_hodnoty
        (subst
	  (cons  "stredkex" stredx)
          (assoc "stredkex" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
        (subst
	  (cons  "stredkey" stredy)
          (assoc "stredkey" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
	(subst
	  (cons  "stredkez" stredz)
	  (assoc "stredkez" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
    )
  )
  (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "N-uhelnik")	;;; jak sted se nastavuje
    (progn							;;; nastavujeme sted "N-uhelnik"
      (setq gl_pam_hodnoty
        (subst
   	  (cons  "strednex" stredx)
          (assoc "strednex" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )
      (setq gl_pam_hodnoty
        (subst 
	  (cons  "stredney" stredy)
          (assoc "stredney" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )
      (setq gl_pam_hodnoty
        (subst
	  (cons  "strednez" stredz)
          (assoc "strednez" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )
    )
  )
)

(defun so:kresli_nuhelnik (/ stred_nu pocvrcholu polomer pol_kresl pocet vzdalenost)
;;; vykreslen n-helnku
;;;; stred_nu   - souadnice stedu (real.slo, real.slo, real.slo)
;;;; pocvrcholu - cel slo reprezentujc poet vrchol n-helnku
;;;; polomer    - real.slo reprezentujc polomr prvn vepsan krunice
;;;; pol_kresl  - real.slo reprezentujc polomr vepsanch krunic
;;;; pocet      - cel slo reprezentujc poet kreslench soustednch n-helnk
;;;; vzdalenost - real.slo reprezentujc vzdlenost mezi n-helnky
  (setq	stred_nu
    (list
      (atof (cdr (assoc "strednex" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredney" gl_pam_hodnoty)))
      (atof (cdr (assoc "strednez" gl_pam_hodnoty)))
    )
  )		;;; pevod t etzc reprezentujcch souadnice
  		;;; do promnn stred (poloky stred jsou typu float)
  (setq pocvrcholu (atoi (cdr (assoc "pocvrcholune" gl_pam_hodnoty))))
		;;; zskn potu vrchol n-helnku z asoc. seznamu gl_pam_hodnoty
  (setq polomer    (atof (cdr (assoc "polomerne"    gl_pam_hodnoty))))
		;;; zskn polomru prvn vepsan krunice z asoc. seznamu gl_pam_hodnoty
  (setq pocet      (atoi (cdr (assoc "pocetne"      gl_pam_hodnoty))))
		;;; zskn poetu kreslench n-helnk z asoc. seznamu gl_pam_hodnoty
  (setq vzdalenost (atof (cdr (assoc "vzdalenostne" gl_pam_hodnoty))))
		;;; zskn vzdlenosti mezi n-helnky z asoc. seznamu gl_pam_hodnoty
  (command)	;;; ukonen vech pedchozch pkaz
  (while (> pocet 0)	;;; dokud je co kreslit opakuj
    (setq pol_kresl (+ polomer (* vzdalenost (- pocet 1))))
		;;; nastaven aktulnho polomru vepsan krunice, kreslenho n-uhelnku
    (command "_polygon" pocvrcholu stred_nu "O" pol_kresl)
    		;;; vykresli n-helnku
    (setq pocet (- pocet 1))	;;; zmeni poet n-helnk o 1
  )
)

(defun so:kresli_kruznici (/ stred_kr polomer pol_kresl pocet vzdalenost)
  (princ "Tady bude vykreslen krunice - ponechno pro zkouku uivatelkem!")
  (princ)
)

(defun so:vazba_prvku (val why editbox slider)
  (princ "Tady bude provzn odpovdajcch dialogovch prvk (slider - editbox)!")
  (princ)
)

(princ "\nFunkce se spout pkazem  (c:SObjekty)  v IDE Visual LISPu")
(princ "\nFunkce se spout pkazem  SObjekty v AutoCADu")